# MIEM VK MlSecOps test task №5

## Тестовое задание для проекта RnD OSS инструментов MLSecOps» и «Инструмент контроля безопасности ML моделей и датасетов»

### Задание 5. Защита от модели-имитатора (Model Stealing)
Цель: Проверка уязвимости модели классификации к краже

1) Выполните model stealing attack, создавая локальную модель, которая имитирует поведение удалённой модели (через API). Предлагается проверять уязвимость на модели классификации на табличных данных.

В тестовом задании под удаленной моделью можно взять обученную модель из открытых источников (напр.  1, 2, 3) и развернуть локально. Под API подразумевается функция predict выбранной модели. (Плюсом вам будет, если вы развернете реальное упрощенное веб API по шаблону)

Кроме вызова подобной функции, любое взаимодействие с моделью на первом этапе запрещено! 

def requestModel(X):
  result = model.predict(X)
  return result

2) Определите меры защиты, чтобы снизить точность "украденной" модели. Это может включать в себя, например, дополнительную обработку датасетов для обучения модели, входных параметров API, выходных результатов функции.
---

# Model Stealing Attack

Данный репозиторий содержит Jupyter Notebook, демонстрирующий реализацию **Model Stealing Attack**. Атака позволяет создать модель, которая копирует поведение целевой модели, обучаясь на синтетически сгенерированных данных.

## Описание проекта

Этот ноутбук демонстрирует реализацию Model Stealing Attack на модели **Keras**, обученной для классификации данных Titanic. Локальная stealing model обучается на синтетических данных и предсказаниях целевой модели.


### Шаги реализации атаки

1. **Загрузка целевой модели и подготовка данных:**
   - Скачивается предварительно обученная модель `titanic_model.h5` из Hugging Face.
   - Исходный датасет Titanic загружается, выполняется предобработка данных

2. **Генерация синтетических данных:**
   - Генерируется 500 синтетических строк, повторяющих статистические и категориальные особенности исходного датасета

3. **Запросы к целевой модели:**
   - Синтетические данные передаются целевой модели.
   - Возвращаются бинарные предсказания целевой модели для синтетических примеров.

4. **Обучение stealing model:**
   - Локальная модель (`RandomForestClassifier`) обучается на синтетических данных и предсказаниях целевой модели.

5. **Оценка stealing model:**
    - **Точность целевой модели**.
    - **Точность stealing model на реальных предсказаниях**.
    - **Точность stealing model на измененных предсказаниях**.
---

### Результаты

Данные по результатам внедрения механизма защиты, который оказывает влияние на выходные вероятности исходной модели:

1. Точность целевой модели на X_test: `0.6902985074626866`
2. Точность stealing model на реальных предсказаниях: `0.6828358208955224`
3. Точность stealing model на измененных предсказаниях: `0.5932835820895522`

Данные по результатам внедрения механизма защиты, который оказывает влияние на входные данные при обучении исходной модели:

1. Точность целевой модели на X_test: `0.6902985074626866`
2. Точность stealing model на реальных предсказаниях: `0.8283582089552238`
3. Точность stealing model на измененных предсказаниях: `0.5932835820895522`

---
